# Questions pour lire le code profs et s'entraîner.
:author: LG pour PIX111, déc 2022.

Remarque: on vous fournit du code prof, qu'il faut désarchiver. Le code est fourni avec quelques commentaires, pas tous (Les commentaires BEGIN CUT et END CUT ainsi que UNCOMMENT nous servent à générer la version étudiante des programmes, vous devez donc les ignorer). Le code compile sans warning et sans erreur. Chez vous, il faudra peut-être modifier le Makefile pour changer `clang-14` en `gcc`. Pour comprendre les corrections, on vous fournit une liste de questions (on ne fournit pas de correction du pendu).



## sudoku (répertoire sudoku-profs)

### dans main.c : 
* le sudoku à résoudre est-il une variable locale ou globale? de quel type est cette variable ? 
* quel mode de résolution a-t-on ajouté par rapport à la résolution interactive par l'utilisateur.rice ?
* par quelle fonction sont modifiées les variables globales `entreeX`, `entreeY` `entreeV`? Pourquoi la fonction ne pouvait-elle pas renvoyer ces 3 valeurs ?
* quelle fonction verifie que l'entrée est correcte ? comment peut-on savoir ce que signifie une entree non valide ?
* à quelle condition sait-on que le sudoku est résolu ? comment cette condition évolue-t-elle dans la fonction `main` ? 

### dans sudoku.c 
* quel est le nombre de tests à 0 effectués pour calculer le nombre de cases libres ? expliquer pourquoi il n'est pas nécessaire de refaire ce calcul à chaque fois.
* dans `lireAction` quelles hypothèses sont faites sur les entrées de l'utilisateur.rice ?
* Donner un invariant `H(i)` valide au début de la boucle while numéro i (en commençant à 0) dans la fonction `estValideH`
* comment implémenter `estValideH` avec une boucle for et une sortie prématurée?
* expliquer avec un dessin comment est implémenté `estValideR`. 
* (bonus, plus difficile) comprendre comment est implémentée la résolution simple automatique du code prof. 


## motus (répertoire motus-profs)

Notez que nous n'avons pas implémenté la recherche dichotomique pour l'instant mais uniquement la recherche simple. 

### dans main.c 

* entre quelles lignes se trouve l'implémentation prof de la boucle réactive du jeu?
* expliquer comment cette boucle se termine.
* Comment est réalisé l'attente d'un mot correct de l'utilisateur ? Est-ce que l'écriture d'un mot de 7 lettres est compté comme une tentative incorrecte dans ce code ?
* le mot de référence est-il stocké dans une variable globale ou une variable locale ?
* pourquoi le dictionnaire n'est-il pas passé en paramètre de la fonction `chercheMot` ? 
* est-ce que le nombre de tentatives totales est correctement calculé ? quel changement doit-on réaliser pour que ce soit le cas?
* Si je change le nom du fichier contenant le dictionnaire dans mon répertoire, dois je recompiler mon projet ? pourquoi ? 

### dans fonction.c
* dans `chargeMots` ligne 58 remplacer la copie de chaîne pour réaliser la copie en copiant case par case la chaine. Quelle est le nombre d'affectations effectuée par cette copie?
* dans `verifieMot`, quel est le cas "facile" pour une lettre de la proposition? Que doit-on faire dans les autres cas ?
* expliquer l'usage de la variable mot_complet dans ce code.
* executer pas à pas à la main l'exécution de `verifieMot`,  avec la proposition ALFRED pour la référence ALBERG. pourquoi statut n'est-il pas passé en paramètre? Que vaut-il à la sortie de la fonction?
* executer `affichemot` à la main avec la proposition ALFRED et le statut donné à la réponse précédente. 
* vérifier en exécutant le code fourni.

### questions plus difficiles dans fonction.c
* (plus difficile). Comme le dictionnaire est trié par ordre alphabétique, la recherche séquentielle de `chercheMot` pourrait s'arrêter plus tôt. Expliquer pourquoi, et comment on pourrait s'en apercevoir. Proposer une modification de `chercheMot`.
* ligne 58 j'utilise une fonction de copie de chaine. Regarder le manuel et expliquer l'appel. 
* dans `lireMot` j'utilise fgets. lire le manuel et expliquer.
