#include <stdio.h> 
#include <stdlib.h> 
#include <time.h>
#include <stdbool.h>
#include <string.h>
#include <ctype.h>
#include "fonction.h" 


// Cette fonction modifie le mot en le capitalisant au fur et à mesure
void normaliseMot(char mot[])
{
  int index= 0;
  while (mot[index] != '\0'){
    mot[index]=toupper(mot[index]);
    index++;
  }
}
int chercheMot(char mot[],int nbMots){
  // TODO 2 : V1 : recherche simple (et on teste tout de suite),
  // BEGIN CUT
  int i=0;
  int j;
  int trouve = 0;
  while (!trouve && i <nbMots){
    // on regarde si mot == dictionnaire[i] (mais on ne peut pas faire d'égalité de tableaux)
    j=0;
    while (j<MAXLETTRE && dictionnaire[i][j]==mot[j]){ j++;}
    if (j==MAXLETTRE) trouve = 1;
    i++;
  }
  return trouve;
  // END CUT
  // UNCOMMENT return 1;
}

// La fonction est presque terminée, il n'y a plus qu'à ajouter les mots de 6 lettres dans le dictionnaire.
int chargeMots(char chemin[])
{
  FILE *f = fopen(chemin,"r");
  if (f==NULL) return -1;
  char oneline[32]; // permet de stocker une ligne sans s'embeter
  int cpt=0;
  
  while (! feof(f)){
    fscanf(f, "%[^\n] ", oneline);
    // attention le \n est contenu dans le mot, le mot a donc une taille +1
    // pas besoin de estMotValide, juste capitalize.
    if (strlen(oneline)==MAXLETTRE+1){
      normaliseMot(oneline);
      printf("On va ajouter ce mot : %s\n",oneline);

      // TODO EN PREMIER
      // copie du mot dans la structure de données interne dictionnaire
      // à la ligne numéro cpt. (à ce stade on enleve le \n et le \0)
      // (indice : utiliser strncpy ou copie 1 à 1
      //BEGIN CUT
      strncpy(dictionnaire[cpt],oneline,MAXLETTRE);
      //END CUT
      // fin TODO
      cpt++;
    }
  }
  fclose(f);
  
  return cpt;
}


int lireMot()
{
  // Indication: utiliser fgets(destination, nbcarsà lire+1, stdin).
  char oneline[MAXLEN+1]; 
  printf("donnez moi un mot de 6 lettres\n");
  // TODO : implémenter
  // BEGIN CUT
  fgets(oneline, MAXLEN+1, stdin);

  
  if (oneline[MAXLETTRE] =='\n'){
    oneline[MAXLETTRE] = '\0';
    normaliseMot(oneline);
    strncpy(mot,oneline,MAXLEN); // vetudiante : copie 1 à 1.
    return 1;
  }
  else 
    return 0;

  //END CUT
  // UNCOMMENT return 0;
}


int verifieMot(char proposition[], char reference[])
{
  // étape 1 : le mot doit exister dans le dictionnaire.
  //TODO : implémenter
  //BEGIN CUT
  if (chercheMot(proposition, nbMots) == 0)
    return 0;// pas le droit d'avoir de l'info
  // END CUT
  // étape 2 : mise à jour du tableau statut pour donner les infos
  // TODO : environ 30 lignes
  //BEGIN CUT
  int i=0;
  int j;
  char cp;
  bool trouve;
  bool mot_complet = true;
  for (i=0; i<MAXLEN; i++){
    // cherche les infos concernant le caractere proposition[i]
    cp = proposition[i];
    if (cp==reference[i]) statut[i] = 1;
    else {
      mot_complet= false;
      // on cherche la lettre dans le mot reference
      j=0;
      trouve = false;
      while (j<MAXLEN && !trouve){
	if (reference[j] == cp) trouve = true;
	j++;
      }
      if (trouve) statut[i] = 2; else statut[i] = 0;
    }
  }
  if (mot_complet) return 1; else return 0;
  // END CUT
  // UNCOMMENT return 0;
}


void afficheMot(char proposition[])
{
  char ch[MAXLEN];

  // TODO : environ 5 lignes
  // BEGIN CUT
  for (int i = 0; i< MAXLEN; i++){
    if (statut[i]==1) ch[i]=proposition[i];
    else if (statut[i] == 2) ch[i] = tolower(proposition[i]);
    else ch[i]='*';
  }
    
  printf("%s\n",ch);
  // END CUT
 
}

void imprimeDico(int nblignes){
  for (int i = 0; i < nblignes; i++){
    printf("dico[%i] contient %s\n",i, dictionnaire[i]);
  }
}
