#include <stdio.h> 
#include <stdlib.h>
#include <stdbool.h> 
#include <time.h>
#include <string.h>
#include <locale.h>
#include <ctype.h>
#include "fonction.h" 

/* Ces variables globales sont utiles dans le jeu */

char dictionnaire[MAXMOTS][MAXLEN];
int nbMots; 
char mot[MAXLEN]; 
int statut[MAXLETTRE]; 
bool debug = true;

/** 
\fn int main(int argc,char *argv[])
 * \brief Cette fonction gère l'algorithme du jeu que vous devrez décrire en pseudo code. 
 * 
 * \param argc le nombre d'arguments de la ligne de commande 
 * \param argv[1] contient le chemin du fichier de mots 
 * \return EXIT_FAILURE si erreur, EXIT_SUCCESS sinon 
*/ 
int main(int argc, char *argv[]) 
{
  // le fichier de mots est en dur.
  // on met à jour les deux variables globales dictionnaire et nbMots
  // le chargement vous est fourni.
  nbMots = chargeMots("dico-fr.txt");
  if (debug && nbMots > 0) printf("chargement de %d mots\n", nbMots);


  // BEGIN CUT
  
  imprimeDico(23);

  char reference[MAXLEN];
  strncpy(reference, dictionnaire[23], MAXLEN);// copie lettre par lettre pour les etud
  printf("référence = %s, mais CHUUUT\n", reference);
  
  int nbtentatives = 0;
  bool trouve=false;
  bool indico;
  int res,res2;

  
  while (!trouve && nbtentatives < 6){
    res = lireMot();
    while (res == 0){ res = lireMot();}
    printf("Mot soumis .... \n");
    printf("%s\n", mot);
    indico = chercheMot(mot, nbMots);
    if (!indico){
      printf("le mot n'existe pas!\n");
      nbtentatives++;
    }
    else {
      res2 = verifieMot(mot, reference);
      if (res2==1){
	printf("Gagné !\n");
	trouve = true;
      }
      else {
	afficheMot(mot); 
	nbtentatives++;
      }
    }
  }
  if (!trouve) printf("Perdu!");

  //END CUT
  
  return EXIT_SUCCESS;
}
